/* ===================================================== */
/* =               ChannelMixer v1.0                   = */
/* =              Gustaf Ullberg 2007                  = */
/* ===================================================== */

class ChannelMixer : public GenericVideoFilter {   
private:
	// Look-up tables 
	int RR[256];
	int RG[256];
	int RB[256];
	int GR[256];
	int GG[256];
	int GB[256];
	int BR[256];
	int BG[256];
	int BB[256];

	// bytes per pixel
	int bpp;

public:
	// Constructor
	ChannelMixer(PClip _child, float inRR, float inRG, float inRB, float inGR, float inGG, float inGB, float inBR, float inBG, float inBB, IScriptEnvironment* env);

	// Gets called each frame
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
};
